#' ---
#' title: |
#'   医薬品開発のための統計解析 第3部1章3節 \
#'   指数曲線のあてはめ \
#'   Green3-1-3c.R
#' author: "Masahiko Katase"
#' date: "2021/3/15"
#' ---

#'# 表示 1.3.12 y = b0x^b1 の関係（b0 = 1） (p.39)

# パワーモデル1　式(1.3.12)
fpower1 <- function(x, b0, b1) {b0 * x^b1}

b0 <- 1
b1 <- c(-1.0, 0.5, 1.0, 1.5)

plot.new()
par(mfcol = c(1, 2))   
par(mar = c(4, 4, 1, 1)) 
plot(NA, xlim = c(0, 5), ylim = c(0, 12),
     xlab = "x", ylab = "y")
for (i in 1:4) {
  curve(fpower1(x, b0, b1[i]), 0, 5,
        ylim = c(0, 12), col = i, add = TRUE)
}

# パワーモデル2　式(1.3.15)
fpower2 <- function(x, ymin, y1, b) {
  ymin + (y1 - ymin) * exp(b * log(x))
}

ymin <- 0
y1   <- 1
b    <- c(-1.0, 0.5, 1.0, 1.5)

plot(NA, xlim = c(0, 5), ylim = c(0, 12),
     xlab = "x", ylab = "y")
for (i in 1:4) {
  curve(fpower2(x, ymin, y1, b[i]), 0, 5,
        ylim = c(0, 12), col = i, add = TRUE)
}