#' ---
#' title: |
#'   医薬品開発のための統計解析 第3部1章4節 \
#'   Emax モデルとロジスティック曲線 \
#'   Green3-1-4a.R
#' author: "Masahiko Katase"
#' date: "2021/4/29"
#' ---

#'# 表示 1.4.1 Emax モデル（b=0.5, 1.0,2.0）(p.43)

fs <- function(x, yinf, x50, b) {yinf / (1 + (x50 / x)^b)}

b <- c(0.5, 1.0, 2.0)

# プロットする領域を消去して上下２分割に設定
plot.new()
par(mfcol = c(2, 1))   
par(mar = c(4, 4, 1, 1)) 

plot(NA, xlim = c(0, 100), ylim = c(0, 10),
     xlab = "x", ylab = "y")
for (i in 1:3) {
  curve(fs(x, 10, 5, b[i]), 0, 100,
        ylim = c(0, 10), col = i, add = TRUE)
}
abline(h = 5, v = 5, lty = 3)

# 縦軸を対数目盛で表示
plot(NA, xlim = c(0.1, 100), ylim = c(0, 10),
     xlab = "x", ylab = "y", log = "x")
for (i in 1:3) {
  curve(fs(x, 10, 5, b[i]), 0.1, 100, log = "x",
        ylim = c(0, 10), col = i, add = TRUE)
}
abline(h = 5, v = 5, lty = 3)