#' ---
#' title: |
#'   医薬品開発のための統計解析 第3部1章4節 \
#'   Emax モデルとロジスティック曲線 \
#'   Green3-1-4c.R
#' author: "Masahiko Katase"
#' date: "2021/4/29"
#' ---

#'# 表示 1.4.6 y ≠ 0の Emax モデル(p.50)

femax <- function(x, y0, yinf, x50, b) {
  y0 + (yinf - y0) / (1 + (x50 / x) ^ b)
}

y0   <- c(0, 2, 10, 10)
yinf <- c(10, 10, 2, 0) 

plot.new()
par(mfcol = c(2, 1))   
par(mar = c(4, 4, 1, 1)) 

plot(NA, xlim = c(0, 100), ylim = c(0, 10),
     xlab = "x", ylab = "y")
for (i in 1:4) {
  curve(femax(x, y0[i], yinf[i], 10, 1), 0, 100,
        ylim = c(0, 10), col = i, add = TRUE)
}
abline(h = 5, v = 10, lty = 3)
abline(h = 6, lty = 3)

plot(NA, xlim = c(0.1, 100), ylim = c(0.1, 10),
     xlab = "x", ylab = "y", log = "x")
for (i in 1:4) {
  curve(femax(x, y0[i], yinf[i], 10, 1), 0.1, 100,
        ylim = c(0, 10), col = i, log = "x", add = TRUE)
}
abline(h = 5, v = 10, lty = 3)
abline(h = 6, lty = 3)


#'# 表示 1.5.1 ゴンペルツ曲線(p.58)

fgom <- function(x, y0, yinf, b) {
  yinf * exp(-log(yinf / y0) * exp(log(b) * x))
}

plot.new()
par(mfcol = c(1, 1))   
par(mar = c(4, 4, 1, 1)) 

curve(fgom(x, 1, 100, 0.45), 0.1, 10,
        ylim = c(0, 100), col = 2, log = "x")
